{$A-,B-,D-,E-,G-,F+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V-,X+,Y-}

{ (C) 06.1997 ᮢ ᥩ ஢, ., (8-275) - 3-39-27. }

unit Files;

interface

type
    SearchRec = record
      Fill: array[1..21] of byte;
      Attr: byte;
      Time: longint;
      Size: longint;
      Name: string[12];
    end;

const        { FileMode = ०  䠩 }
    fmOnlyRead    = 0;
    fmOnlyWrite   = 1;
    fmReadWrite   = 2;

const        { FileAttr = ਡ 䠩      }
    faCommon      = 0;
    faReadOnly    = 1;
    faHidden      = 2;
    faSystem      = 4;
    faVolumeID    = 8;
    faFile        = 39;
    faDirectory   = 16;
    faArchive     = 32;
    faAnyFile     = 63;

const        { SeekFile methods }
    smAbsolute    = 0;      { ६饭   N }
    smToForward   = 1;      {   N ᥩ     }
    smOverEnd     = 2;      {   䠩  N ᥩ }

const        { CheckFileName Mode }
    cmOkJokers       = 44;
    cmNoJokers       = 46;

const        { CheckFileName }
    nePredDir        =  4;       { ..  }
    neRootDir        =  3;       { C:\ }
    neDiskOnly       =  2;       { C:  }
    nePathOnly       =  1;
    neNone           =  0;       {  訡  }
    neNoName         = -1;       {  ப }
    neStringTooLong  = -2;
    neIncorrectDrive = -3;       { ୮  ᪮ }
    neBadSymbol      = -4;
    neBadSyntax      = -5;
    neBadRootDir     = -6;       { Drive = '?:' }
    neBadDriveName   = -7;
    neInvalidPath    = -8;
    neNameTooLong    = -9;
    neExtTooLong     = -10;
    neJokerPresent   = -11;
    neBadMode        = -12;

const        { ChangeFileExt }
    eeNone           =  0;
    eeBadSymbol      = -13;
    eeBadSyntax      = -14;
    eeExtTooLong     = -15;
    eeStringTooLong  = -16;

const        { fPick         }
    peNone           =  0;
    peBigDiskNumber  = -1;
    peStringTooLong  = -2;

const        { File input - output errors      }
    feNone               = 0;
    feFileNotFound       = 2;
    fePathNotFound       = 3;
    feTooManyFiles       = 4;
    feAccessDenied       = 5;
    feInvalidHandle      = 6;    {   䠩,   ਯ }
    feMemoryCorrupt      = 7;
    feNoMemory           = 8;
    feBadShell           = 10;   { ࠢ쭠 樮 । }
    feBadFormat          = 11;
    feInvalidDrive       = 15;
    feCurrentDirDelete   = 16;   { ⪠ 㤠 ⥪騩 ⠫ }
    feInvalidDevice      = 17;   {   ன⢮ }
    feNoMoreFiles        = 18;   {   䠩 - FindFirst/FindNext }
    feUnknownDevice      = 20;
    feBadDiskCommand     = 22;
    feLengthError        = 24;   { ࠢ쭠   ᪮ 樨 }
    feFindError          = 25;
    feNoDosDisk          = 26;   {  DOS -  }
    feWriteError         = 29;   {    }
    feReadError          = 30;
    feGlobalError        = 31;
    feShareViolation     = 32;
    feLockViolation      = 33;
    feStrangeDrive       = 34;   {    }
    feNoDiskSpace        = 101;
    feTimeOutDrive       = 128;  { ᪮  ⮢ }
    feDiskWriteProtect   = 150;
    feNoDiskInDrive      = 152;
    feDataError          = 154;
    feDiskSeekError      = 156;
    feSectorNotFound     = 158;
    fePaperOut           = 159;  {  㬠 }
    feWriteFault         = 160;  { 筮    㬠 }
    feReadFault          = 161;
    feDiskNotFormatted   = 162;

function DirToName(const Dir : string) : string;
function CreateTempFile(const Path : string; const Attrib : byte;
                        var Name : string) : integer;
function CreateFile(const Name : string; const Attrib : byte) : integer;
function OpenFile(const Name : string; const Mode : byte) : integer;
function AppendFile(const Name : string; const Mode : byte) : integer;
function RenameFile(const OldName,NewName : string) : integer;
function TruncateFile(const Number : word) : longint;
function FilePosition(const Number : word) : longint;
function SizeOfFile(const Number : word) : longint;
function FileError : word;
function fError : boolean;
function SaveToFile(const Number : word; var Data; const Size : word) : longint;
function ReadFromFile(const Number : word; var Data; const Size : word) : longint;
function SeekFile(const Number : word; const Position : longint;
                  const Method : byte) : longint;
function SafeFile(const Number : word) : integer;
function CloseFile(const Number : word) : integer;
function DeleteFile(const Name : string) : integer;
function FileGetAttr(const Name : string) : shortint;
function FileSetAttr(const Name : string; const Attr : byte) : integer;
function FileGetTime(const Number : word;
                     var Year,Month,Day,Hour,Min,Sec : word) : integer;
function FileSetTime(const Number,Year,Month,Day,Hour,Min,Sec : word) : integer;
function GetFTime(const Number : word; var DateTime : longint) : integer;
function SetFTime(const Number : word; const DateTime : longint) : integer;
function FindFirst(const Path : string; const Attr : byte;
                   var sr : SearchRec) : integer;
function FindNext(var sr : SearchRec) : integer;
procedure UnpackFTime(const DateTime : longint;
                      var Year,Month,Day,Hour,Min,Sec : word);
function FileExist(const Name : string) : boolean;
function DirectoryExist(const Name : string) : boolean;
function VolumeIDExist(const Disk : byte) : boolean;
function CurrentDisk : byte;
function BootDisk : byte;
function ChangeDisk(const Disk : byte) : integer;
function MkDir(const Dir : string) : integer;
function RmDir(const Dir : string) : integer;
function ChDir(const Dir : string) : integer;
function GetDir(const Disk : byte; var Dir : string) : integer;
function DiskNumber(const Disk : string) : shortint;
function DiskName(Number : byte) : string;
function GetVerify : boolean;
function SetVerify(Verify : boolean) : integer;
function DiskFree(const Disk : byte) : longint;
function DiskSize(const Disk : byte) : longint;
procedure GetData(var Year,Month,Day,DayOfWeek : word);
procedure GetTime(var Hour,Minute,Sec,Sec100 : word);
function SetData(const Year,Month,Day : word) : integer;
function SetTime(const Hour,Minute,Sec,Sec100 : word) : integer;
function LeapYear(Year : word) : boolean;
function CheckFileName(const Name : string; const Mode : byte) : integer;
function FSplit(const FileName : string; var Disk : byte;
                var Path,Name,Ext : string) : integer;
function FPick(var FullName : string; const Disk : byte;
                             const Path,Name,Ext : string) : shortint;
function ChangeFileExt(const SourceName : string; var DestName : string;
                       NewExt : string) : integer;

implementation

function DirToName; assembler;
asm
       push  ds
       lds   si,Dir
       les   di,@Result
       mov   cl,[si]
       sub   ch,ch
       mov   ax,di
       mov   bx,cx
       inc   cx
       cld
       rep   movsb
       mov   di,ax
       cmp   byte ptr es:[di+bx],'\'
       jne   @@Exit
       dec   bl
       mov   es:[di],bl
   @@Exit:
       pop   ds
end;

const
   _FError : word = 0;

procedure LongMul; near; assembler;
asm
       mul   cx
       mov   cx,dx
       mul   bx
       mov   di,dx
       mov   si,ax
       mov   ax,cx
       mul   bx
       mov   dx,ax
       mov   ax,si
       add   dx,di
end;

function DiskFree; assembler;
asm
       mov   ah,36h
       mov   dl,Disk
       int   21h
       cmp   ax,-1
       jb    @@Done
       jmp   @@Exit
   @@Done:
       call  LongMul
   @@Exit:
end;

function DiskSize; assembler;
asm
       mov   ah,36h
       mov   dl,Disk
       int   21h
       cmp   ax,-1
       jb    @@Done
       jmp   @@Exit
   @@Done:
       mov   bx,dx
       call  LongMul
   @@Exit:
end;

procedure GetData; assembler;
asm
   mov  ah,2ah
   int  21h
   les  si,Year
   mov  es:[si],cx
   xor  ch,ch
   mov  cl,dh
   les  si,Month
   mov  es:[si],cx
   mov  cl,dl
   les  si,Day
   mov  es:[si],cx
   mov  cl,al
   les  si,DayOfWeek
   mov  es:[si],cx
end;

procedure GetTime; assembler;
asm
   mov  ah,2ch
   int  21h
   xor  ah,ah
   mov  al,ch
   les  si,Hour
   mov  es:[si],ax
   mov  al,cl
   les  si,Minute
   mov  es:[si],ax
   mov  al,dh
   les  si,Sec
   mov  es:[si],ax
   mov  al,dl
   les  si,Sec100
   mov  es:[si],ax
end;

function LeapYear;
begin
     if Year < 80 then Inc(Year,2000);
     if Year < 100 then Inc(Year,1900);
     LeapYear := (Year mod 4 = 0) and ((Year mod 100 <> 0)
                                   or (Year mod 400 = 0));
end;

function SetData; assembler;
asm
       mov   ah,2bh
       mov   cx,Year
       cmp   cx,80
       jb    @@2000
       cmp   cx,100
       jb    @@1900
       jmp   @@Done
   @@2000:
       add   cx,2000
       jmp   @@Done
   @@1900:
       add   cx,1900
   @@Done:
       mov   dh,byte ptr Month
       mov   dl,byte ptr Day
       int   21h
       cbw
end;

function SetTime; assembler;
asm
       mov   ah,2dh
       mov   ch,byte ptr Hour
       mov   cl,byte ptr Minute
       mov   dh,byte ptr Sec
       mov   dl,byte ptr Sec100
       int   21h
       cbw
end;

function BootDisk; assembler;
asm
   mov  ax,3305h
   int  21h
   mov  al,dl
end;

function GetVerify; assembler;
asm
   mov  ah,54h
   int  21h
   xor  ah,ah
end;

function SetVerify; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   ah,2eh
       xor   dl,dl
       mov   al,Verify
       or    al,al
       jz    @@Zero
       mov   al,1
   @@Zero:
       int   21h
       xor   ax,ax
   @@Exit:
end;

function DiskNumber; assembler;
asm
       les   di,disk
       mov   al,byte ptr es:[di+1]
       cmp   al,'Z'
       jbe   @@Caps
       sub   al,32
   @@Caps:
       sub   al,64
       cmp   al,26
       jna   @@Exit
       mov   al,-1
   @@Exit:
end;

function ChangeDisk; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   bl,Disk
       cmp   bl,0
       jne   @@Do
       xor   ax,ax
       jmp   @@Exit
   @@Do:
       dec   bl
       mov   ax,440eh
       int   21h
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       mov   ah,0eh
       mov   dl,bl
       int   21h
       cbw
   @@Exit:
end;

function CurrentDisk; assembler;
asm
       mov  ah,19h
       int  21h
       inc  al
end;

{ !!!WARNING!!! only for internal use    }
{ Incorrect calling destroy your program }
{ Set DS:DX -> pChar                     }
procedure ConvertStringToPChar; near; assembler;
asm
       mov   ax,di
       mov   cl,byte ptr [si]         { -> DS:SI - PAS-string    }
       xor   ch,ch                    { -> ES:DI - ASCIIZ buffer }
       inc   si
       cld                            { Registers in use: CX,AX  }
       rep movsb
       mov   byte ptr es:[di],0
       mov   dx,ax
       mov   ax,es                    { DS:DX - ASCIIZ-string -> }
       mov   ds,ax                    { ES:DI - end of ASCIIZ -> }
end;
procedure ConvertDTAToPas; near; assembler;
asm
       mov   cx,15            { ७ DTA  sr          }
       cld
       rep movsw
       inc   di
       mov   bx,di
       mov   cl,13
       mov   dl,cl
       rep movsb              { ७   DTA  sr,  }
       mov   di,bx            {  ᤢ      }
       mov   cl,dl
       xor   al,al
       repnz scasb            {  ᨬ     }
       mov   di,bx
       sub   dl,cl
       dec   dl
       mov   es:[di-1],dl     {  -  sr.Name[0] }
       xor   ax,ax            {  ax - ,    }
end;                          { 訡 ᪠  뫮.      }
procedure ProcessingDir(const Dir : string; const Deal : word); near;
assembler;
var
   s : string;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   di,ss
       mov   es,di
       lea   di,s
       lds   si,Dir
       cmp   byte ptr [si],1
       pushf
       call  ConvertStringToPChar
       popf
       je    @@Go
       cmp   byte ptr es:[di-1],'\'
       jne   @@Go
       mov   byte ptr es:[di-1],0
   @@Go:
       mov   ax,Deal
       int   21h
       pop   ds
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       xor   ax,ax
   @@Exit:
end;

function MkDir; assembler;
asm
       mov   ah,39h
       les   di,Dir
       push  es
       push  di
       push  ax
       call  ProcessingDir
end;

function RmDir; assembler;
asm
       mov   ah,3ah
       les   di,Dir
       push  es
       push  di
       push  ax
       call  ProcessingDir
end;

function ChDir; assembler;
asm
       mov   ah,3bh
       les   di,Dir
       push  es
       push  di
       push  ax
       call  ProcessingDir
end;

function GetDir; assembler;
asm
       push  ds
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   dl,Disk
       lds   si,Dir
       mov   ah,47h
       int   21h
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       xor   al,al
       mov   cx,65
       mov   bx,cx
       les   di,Dir
       cld
       repne scasb
       sub   bx,cx
       cmp   bl,1
       pushf
       mov   cx,bx
       mov   al,'\'
       mov   [di-1],al
   @@Next:
       dec   di
       mov   ah,[di]
       mov   [di+2],ah
   loop @@Next
       mov   [di+1],al
       popf
       je    @@NoString
       inc   bl
   @@NoString:
       mov   [si],bl
       xor   ax,ax
   @@Exit:
       pop   ds
end;

function RenameFile; assembler;
var
   OldS,NewS : string;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   di,ss
       mov   es,di
       lea   di,NewS
       lds   si,NewName
       call  ConvertStringToPChar
       mov   bx,dx
       push  es
       lea   di,OldS
       lds   si,OldName
       call  ConvertStringToPChar
       pop   es
       mov   di,bx
       mov   ah,56h
       int   21h
       pop   ds
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       xor   ax,ax
   @@Exit:
end;

function FindFirst; assembler;
var
   s       : string;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   ah,2fh           {   DTA  }
       int   21h
       push  bx               { push bx -> pop siĿ }
       push  es               { push es -> pop ds }
       mov   di,ss                            {  | }
       mov   es,di                            {  | }
       lea   di,s                             {  | }
       lds   si,Path                          {  | }
       call  ConvertStringToPChar             {  | }
       mov   cl,Attr                          {  | }
       xor   ch,ch                            {  | }
       mov   ah,4eh                           {  | }
       int   21h                              {  | }
       pop   ds                            { <---ٳ     㦭  ⠭ }
       pop   si                            { <     ॣ஢        }
       jnc   @@Done                 {                  ConvertDTAToPas     }
       pop   ds                     {                                      }
       mov   _FError,ax             {     .    FindNext    }
       mov   ax,-1                  {  }
       jmp   @@Exit                 {  }
   @@Done:                      {      }
       les   di,sr              { < }
       call  ConvertDTAToPas
       pop   ds
   @@Exit:
end;

function FindNext; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   ah,2fh           {  DTA }
       int   21h
       mov   di,bx
       mov   dx,bx
       push  es               { push es -> pop ds  ७ DTA  sr }
       lds   si,sr
       mov   cx,15
       cld
       rep movsw              { ७ sr  DTA }
       mov   cl,[si]
       inc   si
       rep movsb
       mov   es:[di],ch       { ஢ PAS - ப  ASCII }
       mov   ah,4fh
       int   21h              { FindNext }
       pop   ds
       jnc   @@Done
       pop   ds
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       les   di,sr
       mov   si,dx
       call  ConvertDTAToPas
       pop   ds
   @@Exit:
end;

procedure Find; near; assembler;
var
   sr : SearchRec;
asm
       cmp   _FError,0
       je    @@Ok
       xor   ax,ax
       jmp   @@Exit
   @@Ok:
       push  es        { Path }
       push  di
       push  ax        { Attr }
       mov   bx,ss
       mov   es,bx
       lea   di,sr
       push  es        {  sr  }
       push  di
       call  FindFirst
       xor   bx,bx
       mov   _FError,bx
       cmp   ax,0
       jne   @@FALSE
       mov   ax,1
       jmp   @@Exit
   @@False:
       xor   ax,ax
   @@Exit:
end;

function FileExist; assembler;
asm
       les   di,Name
       mov   ax,faFile
       call  Find
end;

function DirectoryExist; assembler;
asm
       les   di,Name
       mov   bl,byte ptr es:[di]
       cmp   bl,2
       jb    @@Go
       xor   bh,bh
       mov   al,'\'
       cmp   es:[di+bx],al
       pushf
       push  es
       push  di
       jne   @@Go
       dec   byte ptr es:[di]
   @@Go:
       mov   ax,faDirectory
       call  Find
       pop   di
       pop   es
       popf
       jne   @@Exit
       inc   byte ptr es:[di]
   @@Exit:
end;

function VolumeIdExist; assembler;
const
   s  : string[6] = ' :\*.*';
asm
       mov   al,Disk
       cmp   al,27
       jb    @@Ok
       xor   ax,ax
       jmp   @@Exit
   @@Ok:
       cmp   al,0
       ja    @@Go
       call  CurrentDisk
   @@Go:
       add   al,64
       push  ds
       pop   es
       lea   di,s
       mov   [di+1],al
       mov   ax,faVolumeId
       call  Find
   @@Exit:
end;

function DiskName; assembler;
asm
       mov   dx,ds
       mov   al,Number
       cmp   al,27
       lds   si,@Result
       jb    @@Ok
       xor   al,al
       mov   byte ptr [si],0
       jmp   @@Exit
   @@Ok:
       cmp   al,0
       ja    @@Go
       call  CurrentDisk
   @@Go:
       add   al,64
       mov   byte ptr [si],2
       mov   byte ptr [si+1],al
       mov   byte ptr [si+2],':'
   @@Exit:
       mov   ds,dx
end;

function CheckFileName; assembler;
const
   BadSymb : array[0..46] of char =
   (#0,#1,#2,#3,#4,#5,#6,#7,#8,#9,#10,#11,#12,#13,#14,#15,#16,
    #17,#18,#19,#20,#21,#22,#23,#24,#25,#26,#27,#28,#29,#30,#31,
    #32,#34,#43,#44,#47,#58,#59,#60,#61,#62,#91,#93,#124,'*','?');
   NoDouble : array[0..3] of word = ($5c5c,$5c2e,$2e5c,$2e2e);
var
   s : string[129];
asm
       push  ds
       mov   bl,Mode
       cmp   bl,cmOkJokers
       je    @@0
       cmp   bl,cmNoJokers
       je    @@0
       mov   ax,neBadMode
       jmp   @@Exit
   @@DiskFlag: db 0
   @@0:
       mov   byte ptr cs:@@DiskFlag,0
       lds   si,Name
       mov   cl,[si]
       xor   ch,ch
       cmp   cl,0
       jne   @@1
       mov   ax,neNoName
       jmp   @@Exit
   @@1:
       cmp   cl,128
       jb    @@1_1
       mov   ax,neStringTooLong
       jmp   @@Exit
   @@1_1:
       inc   si
       cmp   cl,2
       jne   @@Go
   @@DiskOnly:
       cmp   cl,2
       jne   @@3Letters
       mov   al,':'
       cmp   [si+1],al
       jne   @@Go
   @@CheckDrive:
       mov   ax,si
       dec   ax
       push  ds
       push  ax
       call  DiskNumber
       cmp   al,-1
       jne   @@NoPath
       mov   ax,neBadDriveName
       jmp   @@Exit
   @@NoPath:
       mov   ax,neDiskOnly
       jmp   @@Exit
   @@3Letters:
       mov   ax,5c3ah
       cmp   [si+1],ax
       jne   @@BadSyntax
       mov   ax,si
       dec   ax
       push  ds
       push  ax
       call  DiskNumber
       cmp   al,-1
       je    @@BadRootDir
       mov   ax,neRootDir
       jmp   @@Exit
   @@BadRootDir:
       mov   ax,neBadRootDir
       jmp   @@Exit
   @@Go:
       xor   bx,bx
       cmp   cl,1
       je    @@End2
       mov   ax,5c3ah      { ஢ઠ  :\    }
       cmp   word ptr [si+1],ax
       jne   @@End2
       mov   bx,3
       mov   byte ptr cs:@@DiskFlag,1
   @@End2:
       sub   cx,bx         { ᫨ 뫮 :\ , १  3 ᨬ  }
       jcxz  @@DiskOnly
       cmp   cl,255
       je    @@DiskOnly
       cmp   bx,3
       jne   @@Go2
       mov   ax,si
       dec   ax
       push  ds
       push  ax
       call  DiskNumber
       cmp   al,-1
       jne   @@Go2
       mov   ax,neIncorrectDrive
       jmp   @@Exit
   @@Go2:
       add   si,bx         { cx = Length(Name) }
       cmp   bx,3
       je    @@Go3
       cmp   cl,2
       jb    @@Go3
       mov   ax,'..'
       cmp   [si],ax
       jne   @@Go3
       sub   cl,2
       add   si,2
       cmp   cl,0
       jne   @@Next
       mov   ax,nePredDir
       jmp   @@Exit
   @@Next:
       mov   al,'\'
       cmp   [si],al
       jne   @@Go3
       dec   cl
       inc   si
       cmp   cl,0
       jne   @@Go3
       mov   ax,nePathOnly
       jmp   @@Exit
   @@Go3:
       mov   ax,ss
       mov   es,ax
       xor   ah,ah
       mov   al,byte ptr cs:@@DiskFlag
       lea   di,s          { ds:si - Name^ ; es:di - s^                }
       sub   si,ax
       mov   dx,di
       mov   bl,cl
       add   cl,al
       cld
       rep   movsb
       mov   cl,bl         { cx - Length(s)                            }
       add   dx,ax
       mov   di,dx
       lea   si,BadSymb
       mov   ax,seg @data  { es:di - s^ ; ds:si - BadSymb^ ; ஢ }
       mov   ds,ax         {  ⨬ 㪢.                    }
       mov   bl,Mode
       xor   bh,bh
       cld                 { bx = ᫮  㪢                    }
   @@3: { === 砫 ஢ન === }
       mov   al,[si+bx]
       push  di
       push  cx
       repnz scasb
       pop   cx
       pop   di
       jnz   @@Next3
       cmp   al,'*'
       je    @@Joker
       cmp   al,'?'
       jne   @@NoJoker
   @@Joker:
       mov   ax,neJokerPresent
       jmp   @@Exit
   @@NoJoker:
       mov   ax,neBadSymbol
       jmp   @@Exit
   @@Next3:
       dec   bl
       cmp   bl,255
   jb @@3 { =======  ======= }
       lea   si,NoDouble
       mov   dx,di
       mov   ch,cl         { ஢ઠ  ⢨ (..),(\.),(.\),(\\) }
       mov   al,byte ptr cs:@@DiskFlag
       xor   ah,ah
       add   cl,al
       sub   di,ax
       cmp   cl,1
       je    @@NextCheck
       dec   cl
   @@4: { === 砫 ஢ન === }
       mov   bl,6
   @@41:
       mov   ax,es:[di]
       cmp   [bx+si],ax
       je    @@BadSyntax
       sub   bl,2
       cmp   bl,254
       jne   @@41
       inc   di
       dec   cl
       cmp   cl,0
   ja  @@4 { =======  ======= }
       mov   bl,ch        { ஢ઠ  '*'  '?'      }
       mov   di,dx        {  : cl =  ப       }
       dec   bl           { es:[di+bx] -   ப }
       xor   ah,ah        { ah = 1 - ஢塞 㦥      }
       mov   al,'\'
   @@7:
       cmp   ah,0
       jne   @@71
       cmp   es:[di+bx],al
       jne   @@Next7
       inc   ah
       jmp   @@Next7
   @@BadPath:
       mov   ax,neInvalidPath
       jmp   @@Exit
   @@71:
       mov   al,es:[di+bx]
       cmp   al,'*'
       je    @@BadPath
       cmp   al,'?'
       je    @@BadPath
   @@Next7:
       dec   bl
       cmp   bl,-1
   jg  @@7
   @@NextCheck:
       mov   cl,ch
       mov   di,dx             { ds:dx = ^s     }
       mov   ax,'.\'
       xor   bl,bl
   @@5:                        { ஢ઠ ne.e.xe }
       cmp   es:[di],al
       jne   @@No_Slash
       xor   bl,bl
   @@No_Slash:
       cmp   es:[di],ah
       jne   @@Next5
       inc   bl
   @@Next5:
       cmp   bl,1
       ja    @@BadSyntax
       dec   cl
       inc   di
       cmp   cl,0
   jne @@5
   @@LongCheck:
       xchg  cl,ch
       mov   si,cx
       mov   di,dx
       xor   bx,bx
   @@6:
       cmp   es:[di],ah            { ah = '.' }
       jne   @@61                  { al = '\' }
       inc   ch
       jmp   @@Next6
   @@61:
       cmp   es:[di],al
       jne   @@62                  { ch = ਧ '.'  }
       xor   bx,bx                 { bl = Length(Ext)  }
       xor   ch,ch                 { bh = Length(Name) }
       jmp   @@Next6
   @@62:
       cmp   ch,0
       jne   @@Ext
       inc   bh
       jmp   @@Next6
   @@Ext:
       inc   bl
   @@Next6:
       cmp   bh,9
       jb    @@NameOk
       mov   ax,neNameTooLong
       jmp   @@Exit
   @@NameOk:
       cmp   bl,4
       jb    @@ExtOk
       mov   ax,neExtTooLong
       jmp   @@Exit
   @@ExtOk:
       dec   cl
       inc   di
       cmp   cl,0
       jne   @@6
       mov   di,dx                   { ஢ઠ  ⢨  }
       mov   bx,si
       xor   bh,bh
       cmp   es:[di+bx-1],al
       jne   @@Last
       mov   ax,nePathOnly
       jmp   @@Exit
   @@Last:
       cmp   es:[di+bx-1],ah
       je    @@BadSyntax
       cmp   es:[di],ah
       jne   @@Ok
   @@BadSyntax:
       mov   ax,neBadSyntax
       jmp   @@Exit
   @@Ok:
       xor   ax,ax
   @@Exit:
       pop   ds
end;

procedure MoveString; near; assembler;
asm
       mov   cl,[si]
       sub   ch,ch
       inc   cl
       rep   movsb
end;

function FSplit; assembler;
var
   aPath : string[129];
   aName : string[10];
   aExt  : string[5];
   aDisk : byte;
asm
       push  ds
       lds   si,FileName
       mov   cl,[si]
       xor   ch,ch
       mov   byte ptr ss:[aPath],ch
       mov   byte ptr ss:[aName],ch
       mov   byte ptr ss:[aExt],ch
       mov   byte ptr ss:[aDisk],ch
       inc   cl
       push  si
       push  ds
       push  si
       mov   al,44
       push  ax
       call  CheckFileName
       pop   si
       cmp   ax,0
       jl    @@Exit
       push  ss
       pop   es
       lea   di,aPath
       cmp   al,4
       jne   @@3
       mov   al,3
       mov   es:[di],al
       mov   ax,'..'
       mov   es:[di+1],ax
       mov   al,'\'
       mov   es:[di+3],al
       jmp   @@Ok
   @@3:
       cmp   al,2
       jb    @@1
       push  ax
       mov   al,0
       mov   es:[di],al
       push  ds
       push  si
       call  DiskNumber
       mov   ss:[aDisk],al
       pop   ax
       cmp   al,3
       jne   @@Ok
       mov   word ptr ss:[aPath],5c01h
       jmp   @@Ok
   @@1:
       mov   cl,[si]
       xor   ch,ch
       mov   ax,'\:'
       cmp   [si+2],ax
       jne   @@Go
       push  ds
       push  si
       call  DiskNumber
       mov   ss:[aDisk],al
       add   si,3
       sub   cl,3
   @@Go:
       add   si,cx
       mov   ch,cl
       mov   bx,ss
       mov   es,bx
       xor   bx,bx
       mov   ax,'.\'
       cld
       xor   dx,dx          { dh - ਧ ⮢       }
   @@4:                     { dl - ਧ ⮢ ७ }
       cmp   [si],ah        { bh - ﭨ   ப  }
       jne   @@41           { bl -   ப  . }
       cmp   dl,0
       jne   @@41
       lea   di,aExt
       push  si
       inc   bl
       mov   es:[di],bl
       inc   di
   @@FillExt:
       movsb
       dec   bl
       cmp   bl,0
       ja    @@FillExt
       mov   dl,1
   @@Xor:
       pop   si
       jmp   @@43
   @@41:
       cmp   dh,0
       jne   @@42
       cmp   cl,0
       je    @@44
       cmp   [si],al
       jne   @@42
       cmp   bl,0
       jne   @@44
       mov   dx,101h
       jmp   @@43
   @@44:
       lea   di,aName
       push  si
       mov   es:[di],bl
       inc   di
       inc   si
   @@FillName:
       movsb
       dec   bl
       cmp   bl,0
       ja    @@FillName
       mov   dx,101h
       jmp   @@Xor
   @@42:
       inc   bl
   @@43:
       cmp   dh,0
       jne   @@45
       inc   bh
   @@45:
       dec   si
       dec   cl
       cmp   cl,0ffh
       jne   @@4
       lea   di,aPath
       cmp   ch,bh
       jne   @@5
       xor   ah,ah
       mov   es:[di],ah
       jmp   @@Ok
   @@5:
       mov   es:[di],bl
       inc   di
       add   si,2
       cmp   byte ptr ss:[aDisk],0
       pushf
       je    @@FillPath
       inc   byte ptr es:[di-1]
       mov   es:[di],al
       inc   di
   @@FillPath:
       movsb
       dec   bl
       cmp   bl,0
       ja    @@FillPath
       popf
       je    @@Ok
       dec   di
   @@Ok:
       mov   ax,ss
       mov   ds,ax
       lea   si,aPath
       les   di,Path
       call  MoveString
       lea   si,aName
       les   di,Name
       call  MoveString
       lea   si,aExt
       les   di,Ext
       call  MoveString
       mov   al,byte ptr ss:[aDisk]
       lds   si,Disk
       mov   [si],al
       xor   ax,ax
   @@Exit:
       pop   ds
end;

function ChangeFileExt; assembler;
var
   Name          : string[10];
   Ext           : string[5];
   Path          : string[129];
   temp          : string[146];
   Disk          : byte;
asm
       push  ds
       lds   si,SourceName
       push  si
       push  ds
       push  si
       mov   ax,cmOkJokers
       push  ax
       call  CheckFileName
       pop   si
       or    ax,ax
       jnz   @@Exit
       mov   byte ptr cs:[@@CallingSelector],0
       push  ds
       push  si
       jmp   @@NameIsInStack
   @@1AND2:
       lea   bx,Temp
       push  ss
       push  bx
   @@NameIsInStack:
       lea   bx,Disk
       cmp   byte ptr cs:[@@CallingSelector],1
       jne   @@1AND3
       mov   bl,ss:[bx]
       jmp   @@DiskToStack
   @@1AND3:
       push  ss
   @@DiskToStack:
       push  bx
       lea   bx,Path
       push  ss
       push  bx
       lea   bx,Name
       push  ss
       push  bx
       cmp   byte ptr cs:[@@CallingSelector],1
       je    @@NewExtPut
       lea   bx,Ext
       push  ss
       jmp   @@ExtInStack
   @@NewExtPut:
       les   bx,NewExt
       push  es
   @@ExtInStack:
       push  bx
       cmp   byte ptr cs:[@@CallingSelector],1
       je    @@FPick
   @@FSplit:
       call  FSplit
       cmp   byte ptr cs:[@@CallingSelector],1
       ja    @@CallingSuccess
       inc   byte ptr cs:[@@CallingSelector]
       jmp   @@1AND2
   @@CallingSelector: db 0
   @@FPick:
       call  FPick
       cmp   al,peStringTooLong
       je    @@StringTooLong
       inc   byte ptr cs:[@@CallingSelector]
       jmp   @@1AND2
   @@BadSyntax:
       mov   ax,eeBadSyntax
       jmp   @@Exit
   @@BadSymbol:
       mov   ax,eeBadSymbol
       jmp   @@Exit
   @@ExtTooLong:
       mov   ax,eeExtTooLong
       jmp   @@Exit
   @@StringTooLong:
       mov   ax,eeStringTooLong
       jmp   @@Exit
   @@CallingSuccess:
       cmp   ax,0
       je    @@CompareExt
       cmp   ax,neBadSymbol
       je    @@BadSymbol
       cmp   ax,neExtTooLong
       je    @@ExtTooLong
       jmp   @@BadSyntax
   @@CompareExt:
       lds   si,NewExt
       mov   cl,byte ptr [si]
       sub   ch,ch
       cmp   byte ptr [si+1],'.'
       jne   @@DoCompare
       inc   si
       dec   cl
   @@DoCompare:
       jcxz  @@NoExt
       push  ss
       pop   es
       lea   di,Ext
       inc   di
       inc   di
       inc   si
       repne cmpsb
       jne   @@BadSyntax
   @@NoExt:
       les   di,DestName
       lea   si,Temp
       mov   ax,ss
       mov   ds,ax
 {     inc   byte ptr [si]}
       call  MoveString
       xor   ax,ax
   @@Exit:
       pop   ds
end;

function FPick; assembler;
var
   Temp : string;
asm
       push  ds
       mov   bx,1
       mov   al,Disk
       cmp   al,27
       jb    @@Go
       mov   al,peBigDiskNumber
       jmp   @@Exit
   @@LongString:
       mov   al,peStringTooLong
       jmp   @@Exit
   @@Go:
       lea   di,Temp
       push  ss
       pop   es
       cld
       cmp   al,0
       je    @@Go2
       add   al,64           {  ᪠  ->   }
       mov   es:[di+1],al
       mov   ax,'\:'
       mov   es:[di+2],ax
       mov   bl,4
   @@Go2:
       add   di,bx           { es:[di] - 㤠 த ७ ப }
       lds   si,Path
       mov   cl,[si]
       sub   ch,ch
       inc   si
       mov   dx,805ch        { dl = '\', dh = 128 (  cmp r,128) }
       cmp   [si],dl
       jne   @@AddPath
       or    al,al
       jz    @@AddPath
       inc   si
       dec   cl
   @@AddPath:
       jcxz  @@AddName
       add   bl,cl
       cmp   bl,dh
       ja    @@LongString
       rep   movsb
       cmp   es:[di-1],dl
       je    @@AddName
       mov   es:[di],dl
       inc   di
       inc   bl
   @@AddName:
       lds   si,Name
       mov   cl,[si]
       jcxz  @@Ok
       add   bl,cl
       cmp   bl,dh
       ja    @@LongString
       inc   si
       rep   movsb
   @@AddExt:
       lds   si,Ext
       mov   bh,'.'
       mov   cl,[si]
       jcxz  @@Ok
       inc   si
       inc   bl
       cmp   [si],bh
       jne   @@GoAddExt
       dec   cl
       jcxz  @@Ok
       inc   si
   @@GoAddExt:
       add   bl,cl
       cmp   bl,dh
       ja    @@LongString
       mov   es:[di],bh
       inc   di
       rep   movsb
   @@Ok:
       les   di,FullName
       lea   si,Temp
       push  ss
       pop   ds
       dec   bl
       mov   [si],bl
       call  MoveString
       mov   al,bl
   @@Exit:
       pop   ds
end;

procedure UnpackFTime; assembler;
asm
       push  ds
       mov   bx,word ptr DateTime
       mov   ax,bx
       and   ax,11111b
       shl   ax,1
       lds   si,sec
       mov   [si],ax
       mov   ax,bx
       and   ax,0000011111100000b
       mov   cl,5
       shr   ax,cl
       lds   si,min
       mov   [si],ax
       mov   ax,bx
       and   ax,1111100000000000b
       mov   cl,11
       shr   ax,cl
       lds   si,Hour
       mov   [si],ax
       mov   ax,word ptr DateTime + 2
       mov   dx,ax
       and   ax,1111111000000000b
       mov   cl,9
       shr   ax,cl
       add   ax,1980
       lds   si,Year
       mov   [si],ax
       mov   ax,dx
       and   ax,0000000111100000b
       mov   cl,5
       shr   ax,cl
       lds   si,Month
       mov   [si],ax
       mov   ax,dx
       and   ax,11111b
       lds   si,Day
       mov   [si],ax
       pop   ds
end;

function GetFTime; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   bx,Number
       mov   ax,5700h
       int   21h
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       push  ds
       lds   si,DateTime
       mov   [si],cx
       mov   [si+2],dx
       xor   ax,ax
       pop   ds
   @@Exit:
end;

function SetFTime; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   bx,Number
       mov   cx,word ptr DateTime
       mov   dx,word ptr DateTime + 2
       mov   ax,5701h
       int   21h
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       xor   ax,ax
   @@Exit:
end;

function FileGetTime; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   ax,5700h
       mov   bx,Number
       int   21h
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       push  dx
       push  cx
       les   si,Year
       push  es
       push  si
       les   si,Month
       push  es
       push  si
       les   si,Day
       push  es
       push  si
       les   si,Hour
       push  es
       push  si
       les   si,Min
       push  es
       push  si
       les   si,Sec
       push  es
       push  si
       call  UnpackFTime
       xor   ax,ax
   @@Exit:
end;

function FileSetTime; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   dx,Year
       cmp   dx,1980
       jb    @@ShortYear
       sub   dx,1980
       jmp   @@Do_Set
   @@ShortYear:
       cmp   dx,80
       jb    @@2000
       sub   dx,80
       jmp   @@Do_Set
   @@2000:
       add   dx,20
   @@Do_Set:
       mov   cl,9
       shl   dx,cl
       mov   bx,Month
       and   bx,1111b
       mov   cl,5
       shl   bx,cl
       or    dx,bx
       mov   bx,Day
       and   bx,11111b
       or    dx,bx
       mov   ax,Hour
       and   ax,11111b
       mov   cl,11
       shl   ax,cl
       mov   bx,Min
       and   bx,111111b
       mov   cl,5
       shl   bx,cl
       or    ax,bx
       mov   bx,Sec
       and   bx,111110b
       shr   bx,1
       or    ax,bx
       mov   cx,ax
       mov   bx,Number
       mov   ax,5701h
       int   21h
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       xor   ax,ax
   @@Exit:
end;

function FileGetAttr; assembler;
var
   s : string;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   di,ss
       mov   es,di
       lea   di,s
       lds   si,Name
       call  ConvertStringToPChar
       mov   ax,4300h
       int   21h
       pop   ds
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       mov   ax,cx
   @@Exit:
end;

function FileSetAttr; assembler;
var
   s : string;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   bl,Attr
       mov   di,ss
       mov   es,di
       lea   di,s
       lds   si,Name
       call  ConvertStringToPChar
       mov   ax,4301h
       mov   cl,bl
       xor   ch,ch
       int   21h
       pop   ds
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       xor   ax,ax
   @@Exit:
end;

function CreateFile; assembler;
var
   s : string;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   bl,Attrib
       mov   di,ss
       mov   es,di
       lea   di,s
       lds   si,Name
       call  ConvertStringToPChar
       mov   ah,3ch
       xor   ch,ch
       mov   cl,bl
       int   21h
       pop   ds
       jnc   @@Exit
       mov   _FError,ax
       mov   ax,-1
   @@Exit:
end;

function OpenFile; assembler;
var
   s : string;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   bl,Mode
       mov   di,ss
       mov   es,di
       lea   di,s
       lds   si,Name
       call  ConvertStringToPChar
       mov   ah,3dh
       mov   al,bl
       xor   cx,cx
       int   21h
       pop   ds
       jnc   @@Exit
       mov   _FError,ax
       mov   ax,-1
   @@Exit:
end;

function AppendFile; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       les   di,Name
       push  es
       push  di
       mov   al,Mode
       push  ax
       call  OpenFile
       cmp   ax,-1
       je    @@Exit
       push  ax
       push  ax         { Number }
       xor   ax,ax
       push  ax         { Position }
       push  ax
       mov   al,Mode
       push  ax         { Mode }
       call  SeekFile
       pop   ax
   @@Exit:
end;

function SafeFile; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   bx,Number
       mov   ah,68h
       int   21h
       jnc   @@Done
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       xor   ax,ax
   @@Exit:
end;

function CreateTempFile; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       lds   bx,Path               { ७ Path  Name }
       les   di,Name
       mov   si,bx
       mov   cl,byte ptr [bx]
       inc   cl
       mov   dx,di                 { di    }
       inc   dx
       xor   ch,ch
       cld
       rep movsb
       mov   cl,14                 { ⮢    䠩 }
       xor   al,al
       rep stosb
       mov   ax,es                 { ds:dx - 砫 ப ASCIIZ  DOS }
       mov   ds,ax
       xor   ch,ch
       mov   cl,Attrib
       mov   ah,5Ah
       int   21h
       jnc   @@Done
       pop   ds
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       mov   si,ax                 { ax - # 䠩,  }
       xor   al,al                 { ࠭  si      }
       mov   di,dx
       mov   cl,255
       repne scasb                 { ⠭  ப Name }
       mov   al,254                {  Turbo Pascal             }
       sub   al,cl
       dec   dx
       mov   bx,dx
       mov   byte ptr [bx],al
       mov   ax,si
       pop   ds
   @@Exit:
end;

function FileError; assembler;
asm
   mov  ax,_FError
   mov  _FError,0
end;

function fError; assembler;
asm
       mov  bx,_FError
       cmp  bx,0
       jne  @@True
       xor  ax,ax
       jmp  @@Exit
   @@True:
       mov  ax,1
   @@Exit:
end;

function SaveToFile; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   cx,Size
       mov   bx,Number
       lds   dx,Data
       mov   ah,40h
       int   21h
       pop   ds
       jnc   @@Exit
       mov   _FError,ax
       mov   ax,-1
   @@Exit:
       cwd
end;

function TruncateFile; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   ah,40h
       mov   bx,Number
       xor   cx,cx
       int   21h
       jnc   @@Done
   @@Error:
       mov   _FError,ax
       mov   ax,-1
       cwd
       jmp   @@Exit
   @@Done:
       mov   ax,4201h
       xor   dx,dx
       int   21h
       jc    @@Error
   @@Exit:
end;

function FilePosition; assembler;
asm
       mov   ax,Number
       push  ax
       xor   ax,ax
       push  ax
       push  ax
       inc   al
       push  ax
       call  SeekFile
end;

function SizeOfFile; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   ax,4201h
       mov   bx,Number
       xor   cx,cx
       xor   dx,dx
       int   21h
       jnc   @@Done
   @@Error:
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Done:
       mov   si,ax
       mov   di,dx
       xor   dx,dx
       mov   ax,4202h
       int   21h
       jc    @@Error
       push  ax
       push  dx
       mov   ax,4200h
       mov   cx,di
       mov   dx,si
       int   21h
       pop   dx
       pop   ax
       jc    @@Error
   @@Exit:
end;

function ReadFromFile; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   bx,Number
       mov   cx,Size
       lds   dx,Data
       mov   ah,3fh
       int   21h
       pop   ds
       jnc   @@Exit
       mov   _FError,ax
       mov   ax,-1
   @@Exit:
       cwd
end;

function SeekFile; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   bx,Number
       mov   al,Method
       mov   ah,42h
       mov   dx,word ptr [Position]
       mov   cx,word ptr [Position + 2]
       int   21h
       jnc   @@Exit
       mov   _FError,ax
       mov   ax,-1
       cwd
   @@Exit:
end;

function CloseFile; assembler;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       mov   bx,Number
       mov   ah,3eh
       int   21h
       jnc   @@Closed
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Closed:
       xor   ax,ax
   @@Exit:
end;

function DeleteFile; assembler;
var
   s : string;
asm
       cmp   _FError,0
       je    @@Ok
       mov   ax,-1
       jmp   @@Exit
   @@Ok:
       push  ds
       mov   di,ss
       mov   es,di
       lea   di,s
       lds   si,Name
       call  ConvertStringToPChar
       mov   ah,41h
       int   21h
       pop   ds
       jnc   @@Deleted
       mov   _FError,ax
       mov   ax,-1
       jmp   @@Exit
   @@Deleted:
       xor   ax,ax
   @@Exit:
end;

end.
