{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}

{ Keyboard Include Program (C) ᮢ .., , 1995-97 }

Unit Keyboard;

Interface

   const Insert         = $8000;
         CapsLock       = $4000;
         NumLock        = $2000;
         ScrollLock     = $1000;
         Alt            = 8;
         Ctrl           = 4;
         LeftShift      = 2;
         RightShift     = 1;
         RightAlt       = $800;
         LeftAlt        = $200;
         RightCtrl      = $400;
         LeftCtrl       = $100;

   procedure Play (const fq,time : word);
   function  DelSpace(s__ds : string) : string;
   function  Key : integer;
   procedure Sound(const fq : word);
   procedure Delay(const mSec : word);
   procedure ClearKeyboard;
   procedure ResetKeyboard;
   procedure ResetSwithKey;
   procedure Press(k__p : word);
   procedure Unpress(k__p : word);
   function  Pressed(k__p : word) : boolean;
   function  Active(k__p : word) : boolean;
   procedure CBreakOff;
   procedure CBreakOn;
   procedure WriteKeyString(const s : string);
   procedure Ask(var s : string; l : byte);
   function ScanCode : byte;
             inline(   $10B4     { mov ah,10h }
                      /$16CD     { int 16h    }
                      /$60E4 );  { in  al,60h }
   procedure NoSound;
             inline(   $61E4     { in  al,61h  }
                      /$FC24     { and al,0FCh }
                      /$61E6 );  { out 61h,al  }
   procedure Pause;
             inline(   $B8/$08/$0C  { mov ax,0C08h }
                      /$21CD );     { int 21h      }
   function KeyPressed : boolean;
             inline(   $11B4     { mov ah,11h }
                      /$16CD     { int 16h    }
                      /$0475     { jnz $+6    }
                      /$C032     { xor al,al  }
                      /$02EB     { jmp $+4    }
                      /$01B0 );  { mov al,01h }
   function ReadKey : char;
             inline(   $08B4     { mov ah,08h }
                      /$21CD );  { int 21h    }
   function WinSession : boolean;

Implementation

   function WinSession; assembler;
   asm
      mov  ax,160ah
      int  2fh
      or   ax,ax
      jz   @@True
      mov  al,1
   @@True:
      xor  al,1
   end;

   procedure Delay; assembler;
   asm
      mov  ax,mSec
      mov  dx,1000
      mul  dx
      mov  cx,dx
      mov  dx,ax
      mov  ah,86h
      int  15h
   end;

   procedure Sound; assembler;
   asm
      mov  ax,19
      mov  bx,fq
      cmp  bx,ax
      jnb  @@Go
      mov  bx,ax
   @@Go:
      mov  dx,12h
      mov  ax,3428h
      div  bx
      mov  bx,ax
      mov  al,0b6h
      out  43h,al
      mov  al,bl
      out  42h,al
      mov  al,bh
      out  42h,al
      in   al,61h
      or   al,3
      out  61h,al
   end;

   procedure Play; assembler;
   asm
      mov  ax,fq
      push ax
      call Sound
      mov  ax,time
      mov  bl,100
      mul  bl
      push ax
      call Delay
      in   al,61h
      and  al,0fch
      out  61h,al
   end;

   function DelSpace;
   var i,j  : integer;
       h,e  : boolean;
   begin
     h:=TRUE;e:=TRUE;
     for i:=Length(s__ds) downto 1 do begin
       j:=Length(s__ds);
       if (s__ds[j]<#33) and e then s__ds:=Copy(s__ds,1,j-1)
          else e:=FALSE;
       if (s__ds[1]<#33) and h then s__ds:=Copy(s__ds,2,Length(s__ds)-1)
          else h:=FALSE;
     end { for };
     DelSpace:=s__ds;
   end;

   function Key; assembler;
   asm
       xor AX,AX
       mov ES,AX
       mov AL,ES:[$41A]
       cmp AL,ES:[$41C]
       jne @N
       xor AX,AX
       jmp @E
   @N: mov BL,0
   @I: mov AH,$7
       int $21
       mov AH,0
       inc BL
       cmp AL,0
       je  @I
       cmp BL,2
       jb  @E
       add AX,1000
   @E:
   end;

   procedure ClearKeyboard; assembler;
   asm
      cli
      mov AX,0
      mov ES,AX
      mov AL,ES:[$41A]
      mov ES:[$41C],AL
      sti
   end;

   procedure ResetSwithKey; assembler;
   asm
      cli
      mov AX,0
      mov ES,AX
      mov ES:[$417],AX
      mov ES:[$418],AX
      sti
   end;

   procedure ResetKeyboard; assembler;
   asm
      call ClearKeyboard
      call ResetSwithKey
      mov  ax,NumLock
      push ax
      call Press
   end;

   procedure Press; assembler;
   asm
      xor AX,AX
      mov ES,AX
      mov AX,k__p
      or  AL,AH
      or  AL,ES:[$417]
      mov ES:[$417],AL
   end;

   procedure Unpress; assembler;
   asm
      xor AX,AX
      mov ES,AX
      mov AX,k__p
      or  AH,AL
      mov AL,255
      sub AL,AH
      and AL,ES:[$417]
      mov ES:[$417],AL
   end;

   function Pressed; assembler;
   asm
      xor AX,AX
      mov ES,AX
      mov BL,ES:[$418]
      and BL,128
      mov AH,$12
      int $16
      or  AH,BL
      and AX,k__p
      or  AL,AH
   end;

   function Active; assembler;
   asm
      xor AX,AX
      mov ES,AX
      mov AH,ES:[$417]
      and AX,k__p
      mov AL,AH
   end;

   var
      int_1Bh : pointer;

   const
      cb : byte = $cf    { iret };

   procedure CBreakOff; assembler;
   asm
      mov  ax,351Bh
      int  21h
      mov  dx,offset cb
      mov  si,ds
      mov  di,es
      cmp  si,di
      jne  @@Set_Int
      cmp  bx,dx
      je   @@Exit
   @@Set_Int:
      mov  word ptr int_1Bh,bx
      mov  word ptr int_1Bh+2,es
      mov  ax,251Bh
      int  21h
   @@Exit:
   end;

   procedure CBreakOn; assembler;
   asm
      mov  ax,351Bh
      int  21h
      mov  dx,offset cb
      cmp  bx,dx
      jne  @@Exit
      mov  si,ds
      mov  di,es
      cmp  si,di
      jne  @@Exit
      lds  dx,int_1Bh
      mov  ax,251Bh
      int  21h
      mov  ds,si
   @@Exit:
   end;

   procedure WriteKeyString; assembler;
   asm
      les  di,s
      mov  bl,es:[di]
      or   bl,bl
      jz   @@Exit
      inc  di
      mov  dx,02h
   @@Next:
      mov  cx,es:[di]
      xchg ch,cl
      mov  ah,05h
      int  16h
      add  di,dx
      sub  bl,dl
      or   al,al
      jnz  @@Exit
      cmp  bl,1
      jg   @@Next
   @@Exit:
   end;

   procedure Ask; assembler;
   asm
      mov  al,l
      cmp  al,254
      ja   @@Exit
      inc  al
      push ds
      lds  bx,s
      mov  [bx],al
      mov  dx,bx
      mov  ah,0ah
      int  21h
      mov  cl,[bx+1]
      inc  cl
      sub  ch,ch
      mov  ax,ds
      mov  es,ax
      mov  di,bx
      mov  si,bx
      inc  si
      cld
      rep  movsb
      pop  ds
   @@Exit:
   end;

end.